"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// index.ts
var Indomitable_exports = {};
__export(Indomitable_exports, {
  BaseIpc: () => BaseIpc,
  BaseWorker: () => BaseWorker,
  ClientWorker: () => ClientWorker,
  ClusterManager: () => ClusterManager,
  ConcurrencyManager: () => ConcurrencyManager,
  Indomitable: () => Indomitable,
  IndomitableFetchingStrategy: () => IndomitableFetchingStrategy,
  IndomitableStrategy: () => IndomitableStrategy,
  MainStrategyWorker: () => MainStrategyWorker,
  MainWorker: () => MainWorker,
  ShardClient: () => ShardClient,
  ShardClientUtil: () => ShardClientUtil,
  ThreadStrategyWorker: () => ThreadStrategyWorker,
  Utils: () => Util_exports
});
module.exports = __toCommonJS(Indomitable_exports);

// src/Util.ts
var Util_exports = {};
__export(Util_exports, {
  Chunk: () => Chunk,
  ClientEvents: () => ClientEvents,
  Delay: () => Delay,
  EnvProcessData: () => EnvProcessData,
  Fetch: () => Fetch,
  FetchSessions: () => FetchSessions,
  InternalOps: () => InternalOps,
  LibraryEvents: () => LibraryEvents,
  MainStrategyOps: () => MainStrategyOps,
  MakeAbortableRequest: () => MakeAbortableRequest,
  RawIpcMessageType: () => RawIpcMessageType,
  ThreadStrategyOps: () => ThreadStrategyOps
});
var import_node_https = __toESM(require("https"));
var EnvProcessData = {
  clusterId: Number(process.env.INDOMITABLE_CLUSTER || 0),
  clusterCount: Number(process.env.INDOMITABLE_CLUSTER_TOTAL || 0),
  shardIds: (process.env.INDOMITABLE_SHARDS || "").split(" ").map(Number),
  shardCount: Number(process.env.INDOMITABLE_SHARDS_TOTAL || 0)
};
var MainStrategyOps = /* @__PURE__ */ ((MainStrategyOps2) => {
  MainStrategyOps2["CONNECT"] = "connect";
  MainStrategyOps2["DESTROY"] = "destroy";
  MainStrategyOps2["SEND"] = "send";
  MainStrategyOps2["STATUS"] = "status";
  MainStrategyOps2["RECONNECT"] = "reconnect";
  return MainStrategyOps2;
})(MainStrategyOps || {});
var ThreadStrategyOps = /* @__PURE__ */ ((ThreadStrategyOps2) => {
  ThreadStrategyOps2["REQUEST_IDENTIFY"] = "requestIdentify";
  ThreadStrategyOps2["CANCEL_IDENTIFY"] = "cancelIdentify";
  ThreadStrategyOps2["SHARD_EVENT"] = "shardEvent";
  ThreadStrategyOps2["RETRIEVE_SESSION"] = "retrieveSession";
  ThreadStrategyOps2["UPDATE_SESSION"] = "updateSession";
  return ThreadStrategyOps2;
})(ThreadStrategyOps || {});
var InternalOps = /* @__PURE__ */ ((InternalOps2) => {
  InternalOps2["EVAL"] = "eval";
  InternalOps2["RESTART"] = "restart";
  InternalOps2["RESTART_ALL"] = "restartAll";
  InternalOps2["DESTROY_CLIENT"] = "destroyClient";
  InternalOps2["REQUEST_IDENTIFY"] = "requestIdentify";
  InternalOps2["CANCEL_IDENTIFY"] = "cancelIdentify";
  InternalOps2["SESSION_INFO"] = "sessionInfo";
  InternalOps2["PING"] = "ping";
  return InternalOps2;
})(InternalOps || {});
var ClientEvents = /* @__PURE__ */ ((ClientEvents2) => {
  ClientEvents2["READY"] = "ready";
  ClientEvents2["SHARD_READY"] = "shardReady";
  ClientEvents2["SHARD_RECONNECT"] = "shardReconnect";
  ClientEvents2["SHARD_RESUME"] = "shardResume";
  ClientEvents2["SHARD_DISCONNECT"] = "shardDisconnect";
  ClientEvents2["ERROR"] = "ERROR";
  return ClientEvents2;
})(ClientEvents || {});
var LibraryEvents = /* @__PURE__ */ ((LibraryEvents2) => {
  LibraryEvents2["DEBUG"] = "debug";
  LibraryEvents2["MESSAGE"] = "message";
  LibraryEvents2["ERROR"] = "error";
  LibraryEvents2["WORKER_FORK"] = "workerFork";
  LibraryEvents2["WORKER_READY"] = "workerReady";
  LibraryEvents2["WORKER_EXIT"] = "workerExit";
  LibraryEvents2["SHARD_READY"] = "shardReady";
  LibraryEvents2["SHARD_RECONNECT"] = "shardReconnect";
  LibraryEvents2["SHARD_RESUME"] = "shardResume";
  LibraryEvents2["SHARD_DISCONNECT"] = "shardDisconnect";
  LibraryEvents2["CLIENT_READY"] = "clientReady";
  LibraryEvents2["RAW"] = "raw";
  return LibraryEvents2;
})(LibraryEvents || {});
var RawIpcMessageType = /* @__PURE__ */ ((RawIpcMessageType2) => {
  RawIpcMessageType2["MESSAGE"] = "message";
  RawIpcMessageType2["RESPONSE"] = "response";
  RawIpcMessageType2["ERROR"] = "error";
  return RawIpcMessageType2;
})(RawIpcMessageType || {});
function Fetch(url, options) {
  return new Promise((resolve, reject) => {
    const request = import_node_https.default.request(url, options, (response) => {
      const chunks = [];
      response.on("data", (chunk) => chunks.push(chunk));
      response.on("error", reject);
      response.on("end", () => {
        const code = response.statusCode ?? 500;
        const body = chunks.join("");
        if (code >= 200 && code <= 299)
          resolve(body);
        else
          reject(new Error(`Response received is not ok, Status Code: ${response.statusCode}, body: ${body}`));
      });
    });
    request.on("error", reject);
    request.end();
  });
}
async function FetchSessions(token) {
  const url = new URL("https://discord.com/api/v10/gateway/bot");
  const data = await Fetch(url, {
    method: "GET",
    headers: { authorization: `Bot ${token}` }
  });
  return JSON.parse(data);
}
function Chunk(original, chunks) {
  const array = [];
  for (let i = 0; i < original.length; i += chunks)
    array.push(original.slice(i, i + chunks));
  return array;
}
function Delay(ms) {
  return new Promise((resolve) => setTimeout(() => resolve(), ms));
}
function MakeAbortableRequest(delay) {
  const controller = new AbortController();
  const seconds = Math.round(delay / 1e3);
  const timeout = setTimeout(
    () => controller.abort(new Error(`The request has been aborted in ${seconds} second(s)`)),
    delay
  );
  return { controller, timeout };
}

// src/strategy/IndomitableStrategy.ts
var import_node_path = require("path");
var import_node_events2 = require("events");
var import_node_worker_threads = require("worker_threads");
var import_ws = require("@discordjs/ws");
var import_collection = require("@discordjs/collection");

// src/ipc/MainStrategyWorker.ts
var import_node_events = __toESM(require("events"));

// src/ipc/BaseIpc.ts
var import_crypto = require("crypto");
var BaseIpc = class {
  constructor(manager) {
    this.manager = manager;
    this.promises = /* @__PURE__ */ new Map();
  }
  /**
   * Number of promises pending to be resolved
   */
  get pendingPromises() {
    return this.promises.size;
  }
  /**
   * Rejects all the pending promises
   */
  flushPromises(reason) {
    const error = new Error(reason);
    for (const promise of this.promises.values()) {
      if (promise.controller) {
        promise.controller.signal.removeEventListener("abort", promise.controller.listener);
      }
      promise.reject(error);
    }
    this.promises.clear();
  }
  /**
   * Raw send method without abort controller handling
   * @param transportable Data to send
   */
  send(transportable) {
    return new Promise((resolve, reject) => {
      if (!this.available()) {
        this.manager.emit("debug" /* DEBUG */, "IPC tried to send a message, but the ipc communication is not yet ready");
        return resolve(void 0);
      }
      const repliable = transportable.repliable || false;
      const id = repliable ? (0, import_crypto.randomUUID)() : null;
      const data = {
        id,
        content: transportable.content,
        internal: true,
        type: "message" /* MESSAGE */
      };
      this.sendData(data);
      if (!id)
        return resolve(void 0);
      this.waitForPromise({ id, resolve, reject, signal: transportable.signal });
    });
  }
  /**
   * Taps into message event of worker or primary process to handle ipc communication
   * @internal
   */
  async handleRawResponse(data, errorCallback) {
    try {
      this.manager.emit("raw" /* RAW */, data);
      if (!data.internal)
        return;
      switch (data.type) {
        case "message" /* MESSAGE */:
          return await this.handleUnparsedMessage(data);
        case "response" /* RESPONSE */:
        case "error" /* ERROR */:
          return this.handlePromise(data);
      }
    } catch (error) {
      errorCallback(error);
    }
  }
  waitForPromise(options) {
    let controller;
    if (options.signal) {
      const listener = () => {
        this.promises.delete(options.id);
        options.reject(new Error("This operation is aborted"));
      };
      controller = {
        listener,
        signal: options.signal
      };
      controller.signal.addEventListener("abort", listener);
    }
    this.promises.set(options.id, { resolve: options.resolve, reject: options.reject, controller });
  }
  handlePromise(data) {
    const id = data.id;
    const promise = this.promises.get(id);
    if (!promise)
      return;
    this.promises.delete(id);
    if (promise.controller) {
      promise.controller.signal.removeEventListener("abort", promise.controller.listener);
    }
    if (data.type === "error" /* ERROR */) {
      const content = data.content;
      const error = new Error(content.reason);
      error.stack = content.stack;
      error.name = content.name;
      promise.reject(error);
      return;
    }
    promise.resolve(data.content);
  }
  async handleUnparsedMessage(data) {
    const reply = (content) => {
      if (!data.id)
        return;
      const response = {
        id: data.id,
        content,
        internal: true,
        type: "response" /* RESPONSE */
      };
      this.sendData(response);
    };
    const message = {
      repliable: !!data.id,
      content: data.content,
      reply
    };
    if (!data.content.internal)
      return this.emitMessage(message);
    try {
      await this.handleMessage(message);
    } catch (error) {
      if (!message.repliable)
        return;
      const response = {
        id: data.id,
        content: {
          name: error.name,
          reason: error.reason,
          stack: error.stack
        },
        internal: true,
        type: "error" /* ERROR */
      };
      this.sendData(response);
    }
  }
  emitMessage(message) {
    this.manager.emit("message" /* MESSAGE */, message);
  }
};

// src/ipc/MainStrategyWorker.ts
var MainStrategyWorker = class extends BaseIpc {
  constructor(id, thread, strategy) {
    super(new import_node_events.default());
    this.id = id;
    this.thread = thread;
    this.strategy = strategy;
  }
  available() {
    return true;
  }
  sendData(data) {
    return this.thread.postMessage(data);
  }
  async handleMessage(message) {
    const content = message.content;
    switch (content.op) {
      case "shardEvent" /* SHARD_EVENT */:
        this.strategy.manager.emit(content.event, { ...content.data, shardId: content.shardId });
        break;
      case "requestIdentify" /* REQUEST_IDENTIFY */: {
        const request = {
          op: "requestIdentify" /* REQUEST_IDENTIFY */,
          data: { shardId: content.data.shardId },
          internal: true
        };
        await this.strategy.ipc.send({ content: request, repliable: true });
        message.reply(null);
        break;
      }
      case "cancelIdentify" /* CANCEL_IDENTIFY */: {
        const request = {
          op: "cancelIdentify" /* CANCEL_IDENTIFY */,
          data: { shardId: content.data.shardId },
          internal: true
        };
        await this.strategy.ipc.send({ content: request });
        message.reply(null);
        break;
      }
      case "retrieveSession" /* RETRIEVE_SESSION */: {
        const session = await this.strategy.manager.options.retrieveSessionInfo(content.data.shardId);
        message.reply(session);
        break;
      }
      case "updateSession" /* UPDATE_SESSION */:
        await this.strategy.manager.options.updateSessionInfo(content.data.shardId, content.data.sessionInfo);
        break;
    }
  }
};

// src/strategy/IndomitableStrategy.ts
var IndomitableStrategy = class {
  constructor(manager, ipc, options = {}) {
    this.manager = manager;
    this.ipc = ipc;
    this.workers = new import_collection.Collection();
    this.options = options;
  }
  async spawn(shardIds) {
    const strategyOptions = await (0, import_ws.managerToFetchingStrategyOptions)(this.manager);
    const promises = shardIds.map((shardId) => this.createWorker(shardId, { ...strategyOptions, shardId }));
    await Promise.all(promises);
  }
  async connect() {
    const promises = [];
    for (const worker of this.workers.values()) {
      const content = {
        op: "connect" /* CONNECT */,
        data: {},
        internal: true
      };
      promises.push(worker.ipc.send({ content, repliable: true }));
    }
    await Promise.all(promises);
  }
  async destroy(data = {}) {
    const promises = [];
    for (const worker of this.workers.values()) {
      const content = {
        op: "destroy" /* DESTROY */,
        data,
        internal: true
      };
      promises.push(worker.ipc.send({ content, repliable: true }));
    }
    await Promise.all(promises);
  }
  async reconnect(shardId) {
    const worker = this.workers.get(shardId);
    if (!worker)
      throw new Error(`No worker found for shard #${shardId}`);
    const content = {
      op: "reconnect" /* RECONNECT */,
      data: { recover: import_ws.WebSocketShardDestroyRecovery.Reconnect },
      internal: true
    };
    await worker.ipc.send({ content, repliable: true });
  }
  async send(shardId, data) {
    const worker = this.workers.get(shardId);
    if (!worker)
      throw new Error(`No worker found for shard #${shardId}`);
    const content = {
      op: "send" /* SEND */,
      data,
      internal: true
    };
    await worker.ipc.send({ content, repliable: true });
  }
  async fetchStatus() {
    const collection = new import_collection.Collection();
    const promises = this.workers.map(async (worker, id) => {
      const content = {
        op: "status" /* STATUS */,
        data: {},
        internal: true
      };
      const status = await worker.ipc.send({ content, repliable: true });
      collection.set(id, status);
    });
    await Promise.all(promises);
    return collection;
  }
  async createWorker(shardId, workerData) {
    const path = this.options.path || (0, import_node_path.join)(__dirname, "src/strategy/", "Thread.js");
    const options = { workerData };
    if (this.options.resourceLimits)
      options.resourceLimits = this.options.resourceLimits;
    const thread = new import_node_worker_threads.Worker(path, options);
    await (0, import_node_events2.once)(thread, "online");
    const ipc = new MainStrategyWorker(shardId, thread, this);
    thread.on("error", (error) => {
      throw error;
    }).on("message", (message) => ipc.handleRawResponse(message, () => null));
    this.workers.set(shardId, { thread, ipc });
    return thread;
  }
};

// src/client/ShardClientUtil.ts
var import_node_events4 = __toESM(require("events"));
var import_timers = require("timers");

// src/ipc/BaseWorker.ts
var import_node_events3 = __toESM(require("events"));
var BaseWorker = class extends BaseIpc {
  constructor(manager = new import_node_events3.default()) {
    super(manager);
    process.on("message", (data) => this.handleRawResponse(data, () => null));
  }
  available() {
    return !!process.send;
  }
  sendData(data) {
    process.send(data);
  }
  handleMessage(message) {
    return Promise.resolve();
  }
};

// src/ipc/ClientWorker.ts
var internalOpsValues = Object.values(InternalOps);
var ClientWorker = class extends BaseWorker {
  constructor(shard, manager) {
    super(manager);
    this.shard = shard;
  }
  emitMessage(message) {
    this.shard.emit("message" /* MESSAGE */, message);
  }
  handleMessage(message) {
    if (!internalOpsValues.includes(message.content.op))
      return Promise.resolve();
    const content = message.content;
    switch (content.op) {
      case "eval" /* EVAL */:
        message.reply(this.shard.client._eval(content.data));
        break;
      case "destroyClient" /* DESTROY_CLIENT */:
        this.shard.client.destroy();
        message.reply(null);
    }
    return Promise.resolve();
  }
};

// src/client/ShardClientUtil.ts
var ShardClientUtil = class extends import_node_events4.default {
  constructor(client, manager) {
    super();
    this.client = client;
    this.ipc = new ClientWorker(this, manager);
    this.clusterId = EnvProcessData.clusterId;
    this.clusterCount = EnvProcessData.clusterCount;
    this.shardIds = EnvProcessData.shardIds;
    this.shardCount = EnvProcessData.shardCount;
  }
  /**
   * Gets the current ipc delay
   * @returns A promise that resolves to delay in nanoseconds
   */
  async ping() {
    const content = {
      op: "ping" /* PING */,
      data: {},
      internal: true
    };
    const start = process.hrtime.bigint();
    const end = await this.send({ content, repliable: true });
    return Number(BigInt(end) - start);
  }
  /**
   * Evaluates a script or function on all clusters in the context of the client
   * @returns A promise that resolves to an array of code results
   */
  broadcastEval(script, context = {}) {
    const content = {
      op: "eval" /* EVAL */,
      data: `(${script.toString()})(this, ${JSON.stringify(context)})`,
      internal: true
    };
    return this.send({ content, repliable: true });
  }
  /**
   * Fetches a client property value on all clusters
   * @returns A promise that resolves to an array of code results
   */
  fetchClientValues(prop) {
    return this.broadcastEval((client) => client[prop]);
  }
  /**
   * Gets the cached session info or fetches an updated session info
   * @param update If you want to fetch and update the cached session info
   * @returns A session object
   */
  fetchSessions(update = false) {
    const content = {
      op: "sessionInfo" /* SESSION_INFO */,
      data: { update },
      internal: true
    };
    return this.send({ content, repliable: true });
  }
  /**
   * Restarts the given cluster from the clusterId given
   * @returns A promise that resolves to void
   */
  restart(clusterId) {
    const content = {
      op: "restart" /* RESTART */,
      data: { clusterId },
      internal: true
    };
    return this.send({ content });
  }
  /**
   * Restarts all the clusters Indomitable handles sequentially
   * @returns A promise that resolves to void
   */
  restartAll() {
    const content = {
      op: "restartAll" /* RESTART_ALL */,
      data: {},
      internal: true
    };
    return this.send({ content });
  }
  /**
   * Sends a message to primary process
   * @returns A promise that resolves to void or a repliable object
   */
  async send(transportable) {
    const manager = this.ipc.manager;
    let abortableData;
    if (!transportable.signal && (manager.ipcTimeout !== Infinity && transportable.repliable)) {
      abortableData = MakeAbortableRequest(manager.ipcTimeout);
      transportable.signal = abortableData.controller.signal;
    }
    try {
      return await this.ipc.send(transportable);
    } finally {
      if (abortableData)
        (0, import_timers.clearTimeout)(abortableData.timeout);
    }
  }
};

// src/client/ShardClient.ts
var ShardClient = class {
  constructor(manager) {
    this.manager = manager;
    const clientOptions = manager.clientOptions || {};
    clientOptions.shards = EnvProcessData.shardIds;
    clientOptions.shardCount = EnvProcessData.shardCount;
    if (manager.handleConcurrency) {
      if (!clientOptions.ws)
        clientOptions.ws = {};
      if (!clientOptions.ws.buildStrategy)
        clientOptions.ws.buildStrategy = (ws) => new IndomitableStrategy(ws, new BaseWorker());
    }
    this.client = new manager.client(clientOptions);
    this.client.shard = new ShardClientUtil(this.client, manager);
    this.clusterId = Number(EnvProcessData.clusterId);
  }
  async start(token) {
    this.client.once("ready", () => this.send({ op: "ready" /* READY */, data: { clusterId: this.clusterId } }));
    this.client.on("shardReady", (shardId) => this.send({ op: "shardReady" /* SHARD_READY */, data: { clusterId: this.clusterId, shardId } }));
    this.client.on("shardReconnecting", (shardId) => this.send({ op: "shardReconnect" /* SHARD_RECONNECT */, data: { clusterId: this.clusterId, shardId } }));
    this.client.on("shardResume", (shardId, replayed) => this.send({ op: "shardResume" /* SHARD_RESUME */, data: { clusterId: this.clusterId, shardId, replayed } }));
    this.client.on("shardDisconnect", (event, shardId) => this.send({ op: "shardDisconnect" /* SHARD_DISCONNECT */, data: { clusterId: this.clusterId, shardId, event } }));
    await this.client.login(token);
  }
  send(partial) {
    const shardClientUtil = this.client.shard;
    const content = { ...partial, internal: true };
    shardClientUtil.send({ content, repliable: false }).catch((error) => this.client.emit("ERROR" /* ERROR */, error));
  }
};

// src/concurrency/ConcurrencyManager.ts
var import_ws2 = require("@discordjs/ws");
var ConcurrencyManager = class {
  constructor(concurrency) {
    this.throttler = new import_ws2.SimpleIdentifyThrottler(concurrency);
    this.signals = /* @__PURE__ */ new Map();
  }
  /**
   * Method to try and acquire a lock for identify
   */
  async waitForIdentify(shardId) {
    try {
      let abort = this.signals.get(shardId);
      if (!abort) {
        abort = new AbortController();
        this.signals.set(shardId, abort);
      }
      await this.throttler.waitForIdentify(shardId, abort.signal);
    } finally {
      this.signals.delete(shardId);
    }
  }
  /**
   * Aborts an acquire lock request
   */
  abortIdentify(shardId) {
    const signal = this.signals.get(shardId);
    signal?.abort(`Shard ${shardId} aborted the identify request`);
  }
};

// src/ipc/MainWorker.ts
var internalOpsValues2 = Object.values(InternalOps);
var clientEventsValues = Object.values(ClientEvents);
var MainWorker = class extends BaseIpc {
  constructor(cluster) {
    super(cluster.manager);
    this.cluster = cluster;
  }
  available() {
    return !!this.cluster.worker;
  }
  sendData(data) {
    this.cluster.worker?.send(data);
  }
  async handleMessage(message) {
    this.manager.emit("debug" /* DEBUG */, `Received internal message. op: ${message.content.op} | data: ${JSON.stringify(message.content.data || {})}`);
    const manager = this.manager;
    if (internalOpsValues2.includes(message.content.op)) {
      const content = message.content;
      switch (content.op) {
        case "ping" /* PING */: {
          const end = process.hrtime.bigint().toString();
          message.reply(end);
          break;
        }
        case "eval" /* EVAL */: {
          const data = await manager.broadcast({
            content,
            repliable: true
          });
          message.reply(data);
          break;
        }
        case "sessionInfo" /* SESSION_INFO */: {
          if (content.data.update || !manager.cachedSession)
            manager.cachedSession = await manager.fetchSessions();
          message.reply(manager.cachedSession);
          break;
        }
        case "requestIdentify" /* REQUEST_IDENTIFY */:
          await manager.concurrencyManager.waitForIdentify(content.data.shardId);
          message.reply(null);
          break;
        case "cancelIdentify" /* CANCEL_IDENTIFY */:
          manager.concurrencyManager.abortIdentify(content.data.shardId);
          break;
        case "restart" /* RESTART */:
          await manager.restart(content.data.clusterId);
          break;
        case "restartAll" /* RESTART_ALL */:
          await manager.restartAll();
          break;
      }
    } else if (clientEventsValues.includes(message.content.op)) {
      const content = message.content;
      switch (content.op) {
        case "ready" /* READY */:
          this.manager.emit("clientReady" /* CLIENT_READY */, content.data);
          break;
        case "shardReady" /* SHARD_READY */:
          this.manager.emit("shardReady" /* SHARD_READY */, content.data);
          break;
        case "shardReconnect" /* SHARD_RECONNECT */:
          this.manager.emit("shardReconnect" /* SHARD_RECONNECT */, content.data);
          break;
        case "shardResume" /* SHARD_RESUME */:
          this.manager.emit("shardResume" /* SHARD_RESUME */, content.data);
          break;
        case "shardDisconnect" /* SHARD_DISCONNECT */:
          this.manager.emit("shardDisconnect" /* SHARD_DISCONNECT */, content.data);
      }
    }
  }
};

// src/ipc/ThreadStrategyWorker.ts
var import_node_events5 = __toESM(require("events"));
var import_worker_threads = require("worker_threads");
var ThreadStrategyWorker = class extends BaseIpc {
  constructor() {
    super(new import_node_events5.default());
    import_worker_threads.parentPort.on("message", (message) => this.handleRawResponse(message, () => null));
  }
  build(shard) {
    if (!this.shard)
      this.shard = shard;
  }
  available() {
    return !!import_worker_threads.parentPort;
  }
  sendData(data) {
    return import_worker_threads.parentPort.postMessage(data);
  }
  async handleMessage(message) {
    const content = message.content;
    if (!this.shard)
      throw new Error("Shard isn't initialized yet");
    switch (content.op) {
      case "connect" /* CONNECT */:
        await this.shard.connect();
        message.reply(null);
        break;
      case "destroy" /* DESTROY */:
        await this.shard.destroy(content.data || {});
        message.reply(null);
        break;
      case "send" /* SEND */:
        await this.shard.send(content.data || {});
        message.reply(null);
        break;
      case "reconnect" /* RECONNECT */:
        await this.shard.destroy(content.data);
        message.reply(null);
        break;
      case "status" /* STATUS */:
        message.reply(this.shard.status);
        break;
    }
  }
};

// src/manager/ClusterManager.ts
var import_node_cluster = __toESM(require("cluster"));
var import_timers2 = require("timers");
var ClusterManager = class {
  /**
   * @param options.id ClusterId of this Cluster Manager being created
   * @param options.shards An array of numbers representing the shards that this cluster controls
   * @param options.manager Indomitable instance that spawned this cluster
   */
  constructor(options) {
    this.manager = options.manager;
    this.id = options.id;
    this.shards = options.shards;
    this.ipc = new MainWorker(this);
    this.started = false;
    this.started = false;
    this.ready = false;
    this.readyAt = -1;
    this.worker = void 0;
  }
  /**
   * Destroy associated worker process
   * @param signal Process exit signal
   */
  destroy(signal = "SIGTERM") {
    this.worker?.kill(signal);
    this.cleanup(0, signal);
  }
  /**
   * Respawn associated worker process
   * @param delay Time to wait before restarting worker process
   */
  async respawn(delay = this.manager.spawnDelay) {
    this.manager.emit("debug" /* DEBUG */, `Restarting Cluster ${this.id} containing [ ${this.shards.join(", ")} ] shard(s)...`);
    this.destroy("SIGKILL");
    await Delay(delay);
    await this.spawn();
  }
  /**
   * Spawn a worker process
   */
  async spawn() {
    this.manager.emit("debug" /* DEBUG */, `Spawning Cluster ${this.id} containing [ ${this.shards.join(", ")} ] shard(s)...`);
    this.worker = import_node_cluster.default.fork({
      INDOMITABLE_SHARDS: this.shards.join(" "),
      INDOMITABLE_SHARDS_TOTAL: this.manager.shardCount.toString(),
      INDOMITABLE_CLUSTER: this.id.toString(),
      INDOMITABLE_CLUSTER_TOTAL: this.manager.clusterCount.toString(),
      ...process.env
    });
    this.worker.on("message", (message) => this.ipc.handleRawResponse(message, (error) => this.manager.emit("error" /* ERROR */, error))).on("error", (error) => this.manager.emit("error" /* ERROR */, error)).once("exit", (code, signal) => {
      this.cleanup(code, signal);
      if (!this.manager.autoRestart)
        return;
      this.manager.addToSpawnQueue(this);
    });
    if (!this.started)
      this.started = true;
    this.manager.emit("workerFork" /* WORKER_FORK */, this);
    if (this.manager.waitForReady)
      await this.wait();
    this.manager.emit("debug" /* DEBUG */, `Successfully spawned Cluster ${this.id} containing [ ${this.shards.join(", ")} ] shard(s)! | Waited for cluster ready? ${this.manager.waitForReady}`);
    this.manager.emit("workerReady" /* WORKER_READY */, this);
    await Delay(this.manager.spawnDelay);
  }
  /**
   * Remove all listeners on attached worker process and free from memory
   */
  cleanup(code, signal) {
    this.ipc.flushPromises(`Cluster exited with close code ${code || "unknown"} signal ${signal || "unknown"}`);
    this.worker?.removeAllListeners();
    this.worker = void 0;
    this.ready = false;
    this.readyAt = -1;
    this.manager.emit("debug" /* DEBUG */, `Cluster ${this.id} exited with close code ${code || "unknown"} signal ${signal || "unknown"}`);
    this.manager.emit("workerExit" /* WORKER_EXIT */, code, signal, this);
  }
  /**
   * Waits for this cluster to be ready
   * @returns A promise that resolves to void
   * @internal
   */
  wait() {
    return new Promise((resolve, reject) => {
      const ms = this.manager.spawnTimeout * this.shards.length;
      const seconds = Math.round(ms / 1e3);
      this.manager.emit("debug" /* DEBUG */, `Waiting for client ready event for ${seconds} second(s)`);
      let timeout;
      const listener = (data) => {
        if (data.clusterId !== this.id)
          return;
        this.ready = true;
        this.readyAt = Date.now();
        this.manager.off("clientReady" /* CLIENT_READY */, listener);
        (0, import_timers2.clearTimeout)(timeout);
        resolve();
      };
      timeout = setTimeout(() => {
        this.manager.off("clientReady" /* CLIENT_READY */, listener);
        this.destroy();
        reject(new Error(`Cluster ${this.id} did not get ready in ${seconds} second(s)`));
      }, ms).unref();
      this.manager.on("clientReady" /* CLIENT_READY */, listener);
    });
  }
};

// src/strategy/IndomitableFetchingStrategy.ts
var import_ws3 = require("@discordjs/ws");
var IndomitableFetchingStrategy = class {
  constructor(ipc, options) {
    this.ipc = ipc;
    this.options = options;
  }
  async retrieveSessionInfo(shardId) {
    const content = {
      op: "retrieveSession" /* RETRIEVE_SESSION */,
      event: import_ws3.WebSocketShardEvents.Ready,
      data: { shardId },
      shardId,
      internal: true
    };
    return await this.ipc.send({ content, repliable: true });
  }
  async updateSessionInfo(shardId, sessionInfo) {
    const content = {
      op: "updateSession" /* UPDATE_SESSION */,
      event: import_ws3.WebSocketShardEvents.Ready,
      data: { shardId, sessionInfo },
      shardId,
      internal: true
    };
    await this.ipc.send({ content });
  }
  async waitForIdentify(shardId, signal) {
    const content = {
      op: "requestIdentify" /* REQUEST_IDENTIFY */,
      event: import_ws3.WebSocketShardEvents.Ready,
      data: { shardId },
      shardId,
      internal: true
    };
    const listener = () => this.abortIdentify(shardId);
    try {
      signal.addEventListener("abort", listener);
      await this.ipc.send({ content, repliable: true });
    } finally {
      signal.removeEventListener("abort", listener);
    }
  }
  abortIdentify(shardId) {
    const content = {
      op: "cancelIdentify" /* CANCEL_IDENTIFY */,
      event: import_ws3.WebSocketShardEvents.Ready,
      data: { shardId },
      shardId,
      internal: true
    };
    this.ipc.send({ content, repliable: false }).catch(() => null);
  }
};

// src/Indomitable.ts
var import_node_cluster2 = __toESM(require("cluster"));
var import_node_events6 = __toESM(require("events"));
var import_node_os = __toESM(require("os"));
var import_timers3 = require("timers");
var Indomitable = class extends import_node_events6.default {
  /**
   * @param [options.clusterCount=auto] The amount of clusters to spawn. Expects a number or 'auto'
   * @param [options.shardCount=auto] The number of shards to create. Expects a number or 'auto'
   * @param [options.clientOptions] Options for the Discord.js client
   * @param [options.clusterSettings] Options for the forked process
   * @param [options.ipcTimeout] Time to wait before an ipc request aborts
   * @param [options.spawnTimeout] Time to wait before reporting a failed child process spawn
   * @param [options.spawnDelay] Time to wait before spawning another child process
   * @param [options.autoRestart] Whether to automatically restart shards that have been killed unintentionally
   * @param [options.waitForReady] Whether to wait for clusters to be ready before spawning a new one
   * @param [options.handleConcurrency] Whether you want to handle concurrency properly. Enabling this may result into more stable connection
   * @param [options.client] A Discord.js client class or a modified Discord.js client class
   * @param options.token Discord bot token
   */
  constructor(options) {
    super();
    this.clusterCount = options.clusterCount || "auto";
    this.shardCount = options.shardCount || "auto";
    this.clientOptions = options.clientOptions || { intents: [1 << 0] };
    this.clusterSettings = options.clusterSettings || {};
    this.ipcTimeout = options.ipcTimeout ?? 3e4;
    this.spawnTimeout = options.spawnTimeout ?? 6e4;
    this.spawnDelay = options.spawnDelay ?? 5e3;
    this.autoRestart = options.autoRestart ?? false;
    this.waitForReady = options.waitForReady ?? true;
    this.handleConcurrency = options.handleConcurrency ?? false;
    this.client = options.client;
    this.token = options.token;
    this.clusters = /* @__PURE__ */ new Map();
    this.spawnQueue = [];
    this.concurrencyManager = void 0;
    this.cachedSession = void 0;
    this.busy = false;
  }
  /**
   * Checks the internal private flag if Indomitable is busy
   * @returns Number of clusters in queue
   */
  get isBusy() {
    return this.busy || false;
  }
  // noinspection JSUnusedGlobalSymbols
  /**
   * Gets how many clusters are waiting to be spawned
   * @returns Number of clusters in queue
   */
  get inSpawnQueueCount() {
    return this.spawnQueue.length;
  }
  /**
   * Gets the current session info of the bot token Indomitable currently handles
   * @returns Session Info
   */
  async fetchSessions(force = false) {
    if (!force && this.cachedSession)
      return this.cachedSession;
    this.cachedSession = await FetchSessions(this.token);
    return this.cachedSession;
  }
  /**
   * Spawn a new ShardClient if this instance is a child process, or start a new cluster and IPC server if this instance is the primary process
   * @returns A promise that resolves to void
   */
  async spawn() {
    if (!import_node_cluster2.default.isPrimary) {
      const shardClient = new ShardClient(this);
      await shardClient.start(this.token);
      return;
    }
    if (this.handleConcurrency) {
      const sessions = await this.fetchSessions();
      this.concurrencyManager = new ConcurrencyManager(sessions.session_start_limit.max_concurrency);
      this.emit("debug" /* DEBUG */, "Handle concurrency is currently enabled. Indomitable will automatically handle your identifies that can result to more stable connection");
    }
    if (typeof this.clusterCount !== "number")
      this.clusterCount = import_node_os.default.cpus().length;
    if (typeof this.shardCount !== "number") {
      const sessions = await this.fetchSessions();
      this.shardCount = sessions.shards;
    }
    if (this.shardCount < this.clusterCount)
      this.clusterCount = this.shardCount;
    this.emit("debug" /* DEBUG */, `Starting ${this.shardCount} websocket shards across ${this.clusterCount} clusters`);
    const shards = [...Array(this.shardCount).keys()];
    const chunks = Chunk(shards, Math.round(this.shardCount / this.clusterCount));
    import_node_cluster2.default.setupPrimary({ ...{ serialization: "json" }, ...this.clusterSettings });
    for (let id = 0; id < this.clusterCount; id++) {
      const chunk = chunks.shift();
      const cluster = new ClusterManager({ id, shards: chunk, manager: this });
      this.clusters.set(id, cluster);
    }
    await this.addToSpawnQueue(...this.clusters.values());
  }
  /**
   * Restart specified cluster if this instance is the primary process
   * @param clusterId Id of cluster to restart
   * @returns A promise that resolves to void
   */
  async restart(clusterId) {
    if (!import_node_cluster2.default.isPrimary)
      return;
    const cluster = this.clusters.get(clusterId);
    if (!cluster)
      throw new Error(`Invalid clusterId, or a cluster with this id doesn't exist, received id ${clusterId}`);
    await this.addToSpawnQueue(cluster);
  }
  /**
   * Restart all clusters if this instance is the primary process
   * @returns A promise that resolves to void
   */
  async restartAll() {
    if (!import_node_cluster2.default.isPrimary)
      return;
    await this.addToSpawnQueue(...this.clusters.values());
  }
  /**
   * Sends a message to a specific cluster
   * @returns A promise that resolves to undefined or an unknown value depending on how you reply to it
   */
  async send(id, transportable) {
    const cluster = this.clusters.get(id);
    if (!cluster)
      throw new Error("Invalid cluster id provided");
    let abortableData;
    if (!transportable.signal && (this.ipcTimeout !== Infinity && transportable.repliable)) {
      abortableData = MakeAbortableRequest(this.ipcTimeout);
      transportable.signal = abortableData.controller.signal;
    }
    try {
      return await cluster.ipc.send(transportable);
    } finally {
      if (abortableData)
        (0, import_timers3.clearTimeout)(abortableData.timeout);
    }
  }
  /**
   * Sends a message on all clusters
   * @returns An array of promise that resolves to undefined or an unknown value depending on how you reply to it
   */
  async broadcast(transportable) {
    let abortableData;
    if (!transportable.signal && (this.ipcTimeout !== Infinity && transportable.repliable)) {
      abortableData = MakeAbortableRequest(this.ipcTimeout);
      transportable.signal = abortableData.controller.signal;
    }
    try {
      const results = await Promise.all([...this.clusters.values()].map((cluster) => cluster.ipc.send(transportable)));
      if (!transportable.repliable)
        return void 0;
      return results;
    } finally {
      if (abortableData)
        (0, import_timers3.clearTimeout)(abortableData.timeout);
    }
  }
  /**
   * Reconfigures to launch more shards / clusters without killing the existing processes if possible to avoid big downtimes
   * @remarks Never execute restart() or restartAll() during this process or else you will double restart that cluster / all clusters
   * @returns A promise that resolves to void
   */
  async reconfigure(options = {}) {
    if (!import_node_cluster2.default.isPrimary || this.isBusy)
      return;
    if (!options.shards) {
      const sessions = await this.fetchSessions();
      this.shardCount = sessions.shards;
    }
    this.emit("debug" /* DEBUG */, `Reconfigured Indomitable to use ${this.shardCount} shard(s)`);
    const oldClusterCount = Number(this.clusters.size);
    this.clusterCount = options.clusters || this.clusters.size;
    const shards = [...Array(this.shardCount).keys()];
    const chunks = Chunk(shards, Math.round(this.shardCount / this.clusterCount));
    if (oldClusterCount < this.clusterCount) {
      const count = this.clusterCount - oldClusterCount;
      for (let id = this.clusterCount - 1; id < count; id++) {
        const cluster = new ClusterManager({ id, shards: [], manager: this });
        this.clusters.set(id, cluster);
      }
    }
    if (oldClusterCount > this.clusterCount) {
      const keys = [...this.clusters.keys()].reverse();
      const range = keys.slice(0, oldClusterCount - this.clusterCount);
      for (const key of range) {
        const cluster = this.clusters.get(key);
        cluster.destroy();
        this.clusters.delete(key);
      }
    }
    this.emit("debug" /* DEBUG */, `Reconfigured Indomitable to use ${this.clusterCount} cluster(s) from ${oldClusterCount} cluster(s)`);
    for (const cluster of this.clusters.values()) {
      cluster.shards = chunks.shift();
    }
    this.emit("debug" /* DEBUG */, "Clusters shard ranges reconfigured, moving to spawn queue");
    await this.addToSpawnQueue(...this.clusters.values());
  }
  /**
   * Adds a cluster to spawn queue
   * @internal
   */
  addToSpawnQueue(...clusters) {
    if (!import_node_cluster2.default.isPrimary)
      return Promise.resolve(void 0);
    for (const cluster of clusters) {
      if (this.spawnQueue.some((manager) => manager.id === cluster.id))
        continue;
      this.spawnQueue.push(cluster);
    }
    return this.processQueue();
  }
  /**
   * Destroys the client on a cluster
   * @internal
   */
  async destroyClusterClient(id) {
    const content = {
      op: "destroyClient" /* DESTROY_CLIENT */,
      data: {},
      internal: true
    };
    await this.send(id, { content, repliable: true });
  }
  /**
   * Processes the cluster queue
   * @internal
   */
  async processQueue() {
    if (this.isBusy || !this.spawnQueue.length)
      return;
    this.busy = true;
    this.emit("debug" /* DEBUG */, `Processing spawn queue with ${this.spawnQueue.length} clusters waiting to be spawned....`);
    let cluster;
    while (this.spawnQueue.length > 0) {
      try {
        cluster = this.spawnQueue.shift();
        if (cluster.started) {
          await this.destroyClusterClient(cluster.id);
          await cluster.respawn();
          continue;
        }
        await cluster.spawn();
      } catch (error) {
        this.emit("error" /* ERROR */, error);
        if (cluster && this.autoRestart) {
          this.emit("debug" /* DEBUG */, `Failed to spawn Cluster ${cluster.id} containing [ ${cluster.shards.join(", ")} ] shard(s). Re-queuing if not in spawn queue`);
          this.spawnQueue.push(cluster);
        }
      }
    }
    this.busy = false;
    this.emit("debug" /* DEBUG */, "Cluster Queue Empty! Clusters done booting up");
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  BaseIpc,
  BaseWorker,
  ClientWorker,
  ClusterManager,
  ConcurrencyManager,
  Indomitable,
  IndomitableFetchingStrategy,
  IndomitableStrategy,
  MainStrategyWorker,
  MainWorker,
  ShardClient,
  ShardClientUtil,
  ThreadStrategyWorker,
  Utils
});
//# sourceMappingURL=index.js.map